/*******************************************************************************
quotesend.cpp

example of sending ADD/RWT/DEL of a quote.

*******************************************************************************/

#include "ftsome.h"
#include <string>
#include <map>
#include <thread>

std::thread t1;
FTRevision appVer = {1,0,0};
unsigned long applSign = 732;

FTContext ft_ctx = NULL;
FTAPI_CONF_REC conf = {0};

//METAMARKET CONNECTION DESCRIPTOR
FTConversation_DESC_REC mm_conv_desc;

std::map<std::string, void*> mrk_quoteMap;

long initApplStructs(){
    return 0;
}


/***************************************************************************
*  Input Thread
**************************************************************************/

static int print_quote_choiche = 0;
static int sub_done = 0;

pthread_attr_t *input_thread_attr_;
pthread_t input_thread_;

static int sndnewqte = 0;
static char rwtquoteid[FT_C_ORDER_LEN+1] = {0};
static char delquoteid[FT_C_ORDER_LEN+1] = {0};
static int txquotecho = 0;

static void* input_thread_run(void *arg){
    while(1){
        if(sub_done && !print_quote_choiche){
            printf("\n>>>> 1) send new quote\n");
            printf("\n>>>> 2) edit quote\n");
            printf("\n>>>> 3) del quote\n");
            print_quote_choiche = 1;
            scanf("%d", &txquotecho);
        }else if(txquotecho){
            switch(txquotecho){
            case 1:
                sndnewqte = 1;
                txquotecho = 0;
                break;
            case 2:
                printf("\n>>>> insert quoteid [RWT]\n");
                scanf("%s", rwtquoteid);
                txquotecho = 0;
                break;
            case 3:
                printf("\n>>>> insert quoteid [DEL]\n");
                scanf("%s", delquoteid);
                txquotecho = 0;
                break;
            }
        }else{
            Sleep(1000);
        }
    }
    return 0;
}


std::thread start_input_thread(){
    // return pthread_create(&input_thread_, input_thread_attr_, input_thread_run, NULL);

    return std::thread(input_thread_run, input_thread_attr_);
}

////////////////////////////////APPLICATION LOGIC ON SUBSCRIBED CLASSES ////////////////////////////////////////

long handleFT_C_QUOTE(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_QUOTEPtr ftobj = (FT_C_QUOTEPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - QUOTE");
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - QUOTE");

            std::map<std::string, void*>::iterator it;
            std::string qid(ftobj->QuoteID);
            if((it = mrk_quoteMap.find(qid)) != mrk_quoteMap.end()){
                //we already have this quote
                memcpy(it->second, ftobj, sizeof(FT_C_QUOTERec));
            }else{
                FT_C_QUOTEPtr new_quote = (FT_C_QUOTEPtr)malloc(sizeof(FT_C_QUOTERec));
                FTTraceAppl(FTLevel_Normal, "mrk qte ins by subscr: %s", ftobj->QuoteID);
                memcpy(new_quote, ftobj, sizeof(FT_C_QUOTERec));
                mrk_quoteMap[qid] = (void*)new_quote;
            }
            break;
    }

    return 0;
}


/////////////////////////////////SUBSCRIPTION CALLBACKS////////////////////////////////////////

static void NotifyClass(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    switch(EventType){
        case FTConnectionBroken:
            FTTraceAppl(FTLevel_Error, "onMMSubscribeNotify: connection broken (%d,%d)" , ConversationID, ReqID);
            break;
        case FTClassIdle:
            FTTraceAppl(FTLevel_Normal, "idle received on class %d", ResStruct->ClassID);
            break;
        case FTClassInstance: {
            switch(ResStruct->ClassID){
            case FT_C_QUOTE_ID:
                handleFT_C_QUOTE(ConversationID, ReqID, EventType, ResStruct);
                break;
            default:
                break;
            }
        }
        default:
            break;
    }
}

static void SubscribeResProc(long convID, unsigned long ReqID, long ResultCode, FTSubscribeResStruct *resStruct){
    FTTraceAppl(FTLevel_Normal, "-------- FTOpenSubscribeResProc: classID [%lu], SubscriptionID [%lu]", resStruct->ClassID, resStruct->SubscriptionID);
    FTTraceAppl(FTLevel_Normal, "-------- Result: %s", FTGetErrorString(ResultCode));

    if (ResultCode == FTOK){
        FTTraceAppl(FTLevel_Normal, "-------- Status: %s", (resStruct->SubscribeStatus==FTSubscribeStart)? "Start" : "Stop");
        FTTraceAppl(FTLevel_Normal, "-------- New Table version: %lu; To-Reset signal: %d", resStruct->ClassVersion, resStruct->ResetClass);

        if (resStruct->ResetClass){
            // In this case your request can't be served in incremental manner!
            // Any previous record received have to be considered invalidated and
            // the server will resend all the class content.
            switch(resStruct->ClassID){
                case FT_C_QUOTE_ID:
                    break;
                default:
                    FTTraceAppl(FTLevel_Normal, "-------- Class id not managed - Class %d: New version [%lu]", resStruct->ClassID, resStruct->ClassVersion);

            }
            // Received data are stored into a file
            FTTraceAppl(FTLevel_Normal, "-------- Class Reset - Class %d: New version [%lu]", resStruct->ClassID, resStruct->ClassVersion);
        }
    }
}

/////////////////////////////////QUERY CALLBACKS////////////////////////////////////////


void doSubscr(long ConversationID){
        long res = 0;

        FTTraceAppl(FTLevel_Normal, "subscribing FT_C_QUOTE class..");
        res = FTStartSubscribeClassExt(ConversationID,
                                        FTAckUnrequired,
                                        FTFlowAll,
                                        FT_C_QUOTE_ID,
                                        0, 0,
                                        FTQueryAll,
                                        0,
                                        0, 0,
                                        SubscribeResProc, NotifyClass,
                                        999, 0, 0);
}


/////////////////////////////////MM OPEN-CONV CALLBACKS////////////////////////////////////////
void MMOpenConvCallback(long ConversationID, long ResultCode, FTOpenResStruct *ResStruct){
    long res = 0;
    if((mm_conv_desc.open_conv_ResultCode = ResultCode) == FTOK){
       FTTraceAppl(FTLevel_Normal, "metamarket connection is ON!");
       FTTraceAppl(FTLevel_Normal, "Market Revision: V%d.%d.%d", ResStruct->MarketRevision[0], ResStruct->MarketRevision[1], ResStruct->MarketRevision[2]);

       mm_conv_desc.ConversationID = ConversationID;
       doSubscr(ConversationID);
       sub_done = 1;

   }else{
        FTTraceAppl(FTLevel_Normal, "metamarket connection FAILED! (%d)", ResultCode);
        if(ResultCode == FTInvalidCID){
            FTTraceAppl(FTLevel_Normal, "CID was already used on platform we try to connect with another one..");
                if((res = ConnectToServer(&conf, ft_ctx, 999)) < 0){
                FTTraceAppl(FTLevel_Normal, "ConnectToServer failed [result: %d] program exiting..", res);
                //error
                FTShutdown();
                exit(-1);
            }
        }
    }
}

void MMBrokenConvCallback(long ConversationID, FTBrokenTypeEnum BrokenType){
    FTTraceAppl(FTLevel_Error, "onMMBrokenConvCallback: connection broken (%d, %d)" , ConversationID, BrokenType);
}


/////////////////////////////////ORDER ADD // RWT////////////////////////////////////////

static void QuoteTransactionResProc(long conversationID, unsigned long ReqID, FTSendTransactionResStruct *resStruct){
    Dump_TX_Res_Info(conversationID, ReqID, resStruct, resStruct->EntityAction == FTEntityADD ? "QUOTE-ADD" : "QUOTE-RWT");
    if(resStruct->TransactionStatus==FTTransConversationClosed){
        FTTraceAppl(FTLevel_Normal, "WARNING: Transaction response lost.");
    }
}


static unsigned long quoteReqID = 0;
static unsigned long nextQuoteReqID(){
    return ++quoteReqID;
}


static int rwtid = 0;
static void nextRWT_ID(char *utext){
    sprintf(utext, "RWT%d", rwtid++);
}

static int addid = 0;
static void nextADD_ID(char *utext){
    sprintf(utext, "ADD%d", addid++);
}

long sendNewQuote(){
    long res = 0;
    FT_C_QUOTERec quote;
    memset(&quote, 0, sizeof(FT_C_QUOTERec));
    unsigned long req_id = 0;

    FILE *f;

    char bid_price[CSTR_BUF_LEN];
    char bid_qty[CSTR_BUF_LEN];

    char ask_price[CSTR_BUF_LEN];
    char ask_qty[CSTR_BUF_LEN];
    char tag[FT_C_USER_TEXT_LEN+1];

    if(f = fopen("quote.in", "r")){

        fscanf(f, "%s%s%s%s%s%s%s%s",
                            quote.FTSecID,
                            quote.OperatorID,
                            quote.Currency,
                            bid_price,
                            bid_qty,
                            ask_price,
                            ask_qty,
                            tag);

        fclose(f);
    }else{
        throw "error";
        //error
    }

    quote.Client.Origin = FT_C_ORIGIN_Client;
    quote.CreationDate = 20220426;
    quote.Status = FT_C_ORDER_STATUS_CompFilled;
    // quote.StrategyStatus = 0;
    // quote.CreationTime = 1650968355;
    //quote.Client.Origin = FT_C_ORIGIN_Specialist;
    //quote.AutomaticFlag = FT_C_QUOTE_AUTO_Automatic;

    //sprintf(quote.ClientQuoteID, "algo{%s}", tag);
    //strcpy(quote.ClientQuoteID, "666");

    quote.Bid.Price = atof(bid_price);
    quote.Bid.Qty = atof(bid_qty);

    quote.Ask.Price = atof(ask_price);
    quote.Ask.Qty = atof(ask_qty);


    nextADD_ID(quote.UserText);
    req_id = nextQuoteReqID();

    {
        FTTransactionID TransactionID;
        FTMakeTransactionIDExt(mm_conv_desc.ConversationID, FT_C_QUOTE_ID, &TransactionID);
        FTTraceAppl(FTLevel_Normal, "tx-fly ord ins [%s]", quote.UserText);
        FTTraceAppl(FTLevel_Normal, "sending quote [reqid:%d]", req_id);

        res = FTSendTransactionExt(mm_conv_desc.ConversationID, 
                                    &TransactionID, 
                                    FTEntityADD, 
                                    FT_C_QUOTE_ID, 
                                    1, 
                                    
                                    &quote,
                                    QuoteTransactionResProc,
                                    FTTrue, 
                                    0, 
                                    req_id);
     

        FTTraceAppl(FTLevel_Normal, "FTSendTransactionExt [%s]", FTGetErrorString(res));
    }
    return res;
}


long editQuote(char *quoteid){
    long res = 0;
    FT_C_QUOTERec quote;
    memset(&quote, 0, sizeof(FT_C_QUOTERec));
    unsigned long req_id = 0;

    std::map<std::string, void*>::iterator it;
    std::string qid(quoteid);
    if((it = mrk_quoteMap.find(qid)) != mrk_quoteMap.end()){
        memcpy(&quote, it->second, sizeof(FT_C_QUOTERec));
    }else{
        printf("error");
    }

    FILE *f;

    char bid_price[CSTR_BUF_LEN];
    char bid_qty[CSTR_BUF_LEN];

    char ask_price[CSTR_BUF_LEN];
    char ask_qty[CSTR_BUF_LEN];

    if(f = fopen("quote.rwt", "r")){
        
        fscanf(f, "%s%s%s%s",
                            bid_price,
                            bid_qty,
                            ask_price,
                            ask_qty);

        fclose(f);
    }else{
        throw "error";
        //error
    }

    quote.Bid.Price = atof(bid_price);
    quote.Bid.Qty = atof(bid_qty);

    quote.Ask.Price = atof(ask_price);
    quote.Ask.Qty = atof(ask_qty);

    {
        FTTransactionID TransactionID;
        FTMakeTransactionIDExt (mm_conv_desc.ConversationID, FT_C_QUOTE_ID, &TransactionID);
        FTTraceAppl(FTLevel_Normal, "sending quote [reqid:%d]", req_id);

        res = FTSendTransactionExt(mm_conv_desc.ConversationID, 
                                    &TransactionID, 
                                    FTEntityRWT, 
                                    FT_C_QUOTE_ID, 
                                    1, 
                                    &quote, 
                                    QuoteTransactionResProc, 
                                    FTTrue, 
                                    0, 
                                    req_id);

        FTTraceAppl(FTLevel_Normal, "FTSendTransactionExt [%s]", FTGetErrorString(res));
    }
    return res;
}

long delQuote(char *quoteid){
    long res = 0;
    FT_C_QUOTERec quote;
    memset(&quote, 0, sizeof(FT_C_QUOTERec));
    unsigned long req_id = 0;

    std::map<std::string, void*>::iterator it;
    std::string qid(quoteid);
    if((it = mrk_quoteMap.find(qid)) != mrk_quoteMap.end()){
        memcpy(&quote, it->second, sizeof(FT_C_QUOTERec));
    }else{
        printf("error");
    }

    {
        FTTransactionID TransactionID;
        FTMakeTransactionIDExt (mm_conv_desc.ConversationID, FT_C_QUOTE_ID, &TransactionID);
        FTTraceAppl(FTLevel_Normal, "sending quote [reqid:%d]", req_id);

        res = FTSendTransactionExt(mm_conv_desc.ConversationID, 
                                    &TransactionID, 
                                    FTEntityDEL, 
                                    FT_C_QUOTE_ID, 
                                    1, 
                                    &quote, 
                                    QuoteTransactionResProc, 
                                    FTTrue, 
                                    0, 
                                    req_id);

        FTTraceAppl(FTLevel_Normal, "FTSendTransactionExt [%s]", FTGetErrorString(res));
    }
    return res;
}



/////////////////////////////////MAIN////////////////////////////////////////
int main(int argc, char *argv[]){
    long result = FTOK;

    initApplStructs();

    if(LoadConfigByFile(&conf)){
        printf("PARAMETERS ERROR! exiting..\n");
        return 1;
    }

    //create an ft-context and set its properties
    ft_ctx = FTCreateContext();
    FTSetContextAttribute(ft_ctx, CTX_COMPRESSED, "ZIP");
    FTSetContextAttribute(ft_ctx, CTX_APPL_AUTHFILE, conf.license_file);

    //initialize ft-framework
    if(InitializeFTAPI(&conf, ft_ctx) != FTOK){
        //error
        FTShutdown();
        return 1;
    }

    conf.OpenResProc = MMOpenConvCallback;
    conf.BrokenProc = MMBrokenConvCallback;
    conf.UserType = FTUserTrader;

    //remember that connection will not be done until you call at least one FTRun() call.
    if(ConnectToServer(&conf, ft_ctx, 999) < 0){
        //error
        FTShutdown();
        return 1;
    }

    std::thread tt = start_input_thread();
    // sndnewqte = 1;
    // txquotecho = 0;


/***********************************************************************************
** MAIN EVENT LOOP **
 Calling FTRun() ensures that all requests (subscriptions, transactions, queries ..) 
 will be handled by FTAPI durig program lifecycle.
***********************************************************************************/
    unsigned long times = 0; 
    do{
        if(FTRun() != FTOK){
            FTShutdown();
            return 1;
        }
        times++;
        if(!(times % 10)){
            FTTraceAppl(FTLevel_Full, "FTRun called %lu times", times);
        }
        FTSocketSelect();

        if(rwtquoteid[0]){
            FTTraceAppl(FTLevel_Normal, "sending quote RWT: [%s]", rwtquoteid);
            editQuote(rwtquoteid);
            memset(rwtquoteid, 0, sizeof(rwtquoteid));
            print_quote_choiche = 0;
        }

        if(delquoteid[0]){
            FTTraceAppl(FTLevel_Normal, "sending quote DEL: [%s]", delquoteid);
            delQuote(delquoteid);
            memset(delquoteid, 0, sizeof(delquoteid));
            print_quote_choiche = 0;
        }
        if(sndnewqte){
            FTTraceAppl(FTLevel_Normal, "sending quote ADD");
            sendNewQuote();
            print_quote_choiche = 0;
            sndnewqte = 0;
        }

    }while(1);

    tt.join();
    //unreachable code
    return 0;
}


